// Copyright (c) 2000, 2002 - 2011 Citadel LLC, Confidential
// Information of Citadel LLC, or its affiliates.  All rights reserved.

#define BOOST_AUTO_TEST_MAIN
#include <boost/test/unit_test.hpp>
#include <boost/make_shared.hpp>
#include <boost/serialization/nvp.hpp>
#include <boost/serialization/vector.hpp>
#include <boost/archive/xml_iarchive.hpp>
#include <boost/archive/xml_oarchive.hpp>
#include <fstream>
#include <sstream>

#include "Variant.H"
#include "VariantDict.H"

using namespace boost::serialization;

BOOST_AUTO_TEST_CASE(TestVariantStuff)
{
	std::vector<std::string> rcpKeys; rcpKeys.push_back("BumpSize"); rcpKeys.push_back("TwoSizedRisk");
	std::vector<Variant> rcpValues; rcpValues.push_back(Variant("0.0001")); rcpValues.push_back(Variant("True"));

	std::vector<std::string> rcKeys; rcKeys.push_back("DELTA"); rcKeys.push_back("GAMMA");
	VariantDictPtr riskCfg = VariantDictPtr(new VariantDict(rcpKeys, rcpValues));

	std::vector<Variant> configurationVec;
	for (size_t w = 0; w < 2; ++w)
	{
		std::vector<Variant> innerConfigurationVec;
		for (size_t i = 0; i < 2; ++i)
		{
			std::vector<std::string> configKeys; configKeys.push_back("Key");
			std::vector<Variant> configValues; configValues.push_back(riskCfg);
			VariantDictPtr configs = VariantDictPtr(new VariantDict(configKeys, configValues));
			innerConfigurationVec.push_back(Variant(configs));
		}
		configurationVec.push_back(Variant(innerConfigurationVec));
	}

    std::stringstream ss;
    {
        boost::archive::xml_oarchive oa(ss);
        oa << boost::serialization::make_nvp("configurationVec", configurationVec);
    }

	std::ofstream fout("V:\\grqr\\crusby\\doc_fail.xml");
	fout << ss.str();
	fout.close();

    std::vector<Variant>    configurationVecSerialized;
    {
        boost::archive::xml_iarchive ia(ss);
        ia >> boost::serialization::make_nvp("configurationVec", configurationVecSerialized);
    }

    BOOST_CHECK(true);
}

