#ifndef VARIANT_DICT_H
#define VARIANT_DICT_H

#include "Variant.h"

#include <string>
#include <map>
#include <vector>
#include <boost/shared_ptr.hpp>
#include <boost/serialization/access.hpp>
#include <boost/serialization/export.hpp>
#include <boost/serialization/tracking.hpp>

class VariantDict
{
public:
    VariantDict();

	VariantDict( const std::vector< std::string >    & keys,
				 const std::vector< Variant > &        values );

	Variant getValue( const std::string & key ) const;

	template <typename Archive>
	friend void serialize( Archive & ar, VariantDict & obj, const unsigned int file_version );
	friend class boost::serialization::access;

private:
	VariantDict(const VariantDict&);
	VariantDict operator=(const VariantDict&);

	typedef			std::map< std::string, Variant > VariantMap;
	VariantMap		_variantMap;
};

#endif
